import React, { Component } from 'react';
import Service from './service';
import BookEdit from './bookedit';

export default class Books extends Component {
  constructor(props) {
    super(props);
    
    this.state = {
      books: [],
    };
  }
  
  componentDidMount() {
    Service.getBooks()
      .then(books => this.setState({ books }));
  }
  
  editBook(book) {
    this.setState({ bookToEdit: book });
  }
  
  updatePrice(id, price) {
    const books = this.state.books.map(book =>
      book.id === id ? {...book, price } : book);

    this.setState({ books });
  }
  
  render() {
    return <div>
      <table>
        <tbody>
        	<tr><th>Title</th><th>Author</th><th>Price</th><th></th></tr>
        	{
        	  this.state.books.map(book =>
        	  <tr key={ book.id }>
        	  	<td>{ book.title }</td>
        	  	<td>{ book.author }</td>
        	  	<td>{ book.price }</td>
        	  	<td><button onClick={ () => this.editBook({...book}) }>edit</button></td>
        	  </tr>)
        	}
        </tbody>
      </table>
      
      {
        this.state.bookToEdit ? <BookEdit book={ this.state.bookToEdit } updatePrice={ (id, price) => this.updatePrice(id, price) }/> : ''
      }
    </div>;
  }
}